/*
 *  AudioClipPlayer.h
 *  
 *  A class for managing the playback of .wav files
 *  Each instance of this class can play one file
 *  up to ten times concurrently.
 *
 *  Once all ten voices are used, further calls to playClip()
 *  are ignored until one of the voices frees up (i.e. the
 *  voice reached the end of the .wav file).
 *
 *  The .wav file is loaded into all voices upon construction 
 *  of this calss. That's done in order to minimize the
 *  latency of the subsequent calls to playClip().
 *  
 *
 *  Created by Roy Fejgin on 2/7/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */



#import "mo_audio.h"
#import "FileWvIn.h"
#import <list>

using namespace stk;

#define NUM_PLAYERS   10
class AudioClipPlayer
{
public:
    AudioClipPlayer(const char* path, SAMPLE scale);
    void playClip();        
    
    SAMPLE tick();
private:
    FileWvIn* m_players[NUM_PLAYERS];
    bool m_active[NUM_PLAYERS];
    SAMPLE m_scale;
};