#include "DelayFilter.h"

DelayFilter::DelayFilter(int delay, int maxDelay, LoadType loadType)
: FIRFilter(maxDelay+1, (loadType == LOAD_ZERO) ? true : false)
{
  changeDelay(delay);

  if (loadType == LOAD_RANDOM) {
    for (int i = 0; i < maxDelay+1; i++) {
      SAMPLE randomSample = (((MyFloat64)rand()) / ((MyFloat64)(RAND_MAX))) * 2 - 1;
      m_delayBuffer.pushPop(randomSample);
    }
  }
}

SAMPLE DelayFilter::generateOutput(SAMPLE input)
{
  return m_delayBuffer.pushPop(input);
}

void DelayFilter::changeDelay(int delay)
{
  m_delayBuffer.setDelay(delay);
  m_delay = delay;
}
