//
//  ES1Renderer.h
//  SonicSlingShot
//
//  Created by Roy Fejgin on 1/29/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "ESRenderer.h"
#import "WorldModel.h"
#import "ui_slingshot.h"
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>
#import <map>
#import "mo_touch.h"
#import "ui_projectiles.h"

@interface ES1Renderer : NSObject <ESRenderer>
{
@private
	EAGLContext *context;
	
	// The pixel dimensions of the CAEAGLLayer
	GLint backingWidth;
	GLint backingHeight;
	
	// The OpenGL names for the framebuffer and renderbuffer used to render to this view
	GLuint defaultFramebuffer, colorRenderbuffer;
    
    WorldModel* pModel;
    UI_SlingShot* pUISling;
    UI_Projectiles* pUIProj;
}

- (void) render;
- (void) loadTextures;
- (BOOL) resizeFromLayer:(CAEAGLLayer *)layer;
- (void) touchEvent:(const std::map<int, MoTouchTrack>*) touchPts: (UIView*) view;
- (GLfloat) renderAudio;
//void touchEvent(const std::map<int, MoTouchTrack> & touchPts, UIView * view);


@end
