#ifndef __FIR_FILTER_
#define __FIR_FILTER_

#include "AudioChainElement.h"
#include "CircularBuffer.h"

// An abstract FIR (Finite Impulse Response) filter
class FIRFilter : public AudioChainElement
{
public:
  FIRFilter(int maxIRLength, bool initBuffer = true, SAMPLE initValue = 0)
    : m_delayBuffer(maxIRLength, 0, initBuffer, initValue) {}
  
  ~FIRFilter(void){}

protected:
  virtual SAMPLE generateOutput(SAMPLE input) = 0;

protected:
  CircularBuffer<SAMPLE> m_delayBuffer;
};


#endif //__FIR_FILTER_