#include "MovingAvgFilter.h"

MovingAvgFilter::MovingAvgFilter(int numPoints) : FIRFilter(numPoints+1)
{
  m_numPoints = numPoints;
}

SAMPLE MovingAvgFilter::generateOutput(SAMPLE input)
{
  SAMPLE output = 0.0;
  
  //Store the current input in the delay buffer
  m_delayBuffer.pushPop(input);

  // Calculate the average
  for (int i=0; i < m_numPoints; i++) {
    output += m_delayBuffer.peekBack(i);
  }
  output /= m_numPoints;

  return output;
}
