/*
 *  ui_element.h
 *  
 *  Abstract UI element - serves as base class all classes forming the GUI
 *
 *  Created by Roy Fejgin on 2/1/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef __UI_ELEMENT__
#define __UI_ELEMENT__

#include "WorldModel.h"

class UI_Element
{
public:
    // Constructor
    UI_Element(WorldModel* pModel): m_pModel(pModel) {}

    // Draw self. Each subclass implements its own version of this function.
    virtual void draw() { return; };

protected:
    WorldModel* m_pModel;
};


// hack... access to texture map handles
extern GLuint g_texture[3];


#endif //__UI_ELEMENT__