/*
 *  ui_slingshot.h
 *  
 *  Visual representaiton of the sonic slingshot.
 *  It shows touch points and a vibrating string.
 *
 *  Created by Roy Fejgin on 2/1/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#include "ui_element.h"

class  UI_SlingShot : public UI_Element
{
public:
    
    UI_SlingShot(WorldModel* pModel, GLuint texture): UI_Element(pModel), m_texture(texture) {}
    ~UI_SlingShot(){}
    
    virtual void draw();

private:
    void drawTouch(CGPoint point, bool isProj=false);
    void drawCord(CGPoint p1, CGPoint p2, Float32 vibration);
    
    GLuint m_texture;

};
